var XX,YY, // Mouse coordinates
startX,startY, // Mouse drag start coordinates
winState='normal', // Current window state ('minMax', 'minNormal') (used to stop refreshing when viewport hidden)
mixedEvents='', // Mouse / keyboard event string sent to server. Events are separated by a slash
keyEvents='', // Keyboard events
lastEventTime=0, // Timestamp of last keyboard / mouse event
lastResponseTime=0, // Timestamp of last async response
refreshASAP=0, // Set to 1 to indicate a refresh is requested ASAP
refreshStop=0, // Set to 1 to indicate to stop refreshing (debug)
focusInterval=0,focusIntervalSuspended=0, // window interval used to keep focus on keys2 input, toggled with resumeFocus(0/1);
inputBoxDragInProgress=0,
altClickDragInProgress=0, // set to one when an alt-click drag has been initiated
altClickX, altClickY, // alt click coordinates
sendEventsInProgress=0, // 1 if a sendData request is in progress
maskDragInProgress=0,
inputBoxFocused=0,
clipboardBoxFocused=0,
maskFaded=1, // 1 to indicate mouse is over controls area and a mask is shown over screen
mouseIn=1, // 1 if mouse over mask/window, used to prevent sending mouse events while mouse is out of screen area
dbsl=0,dbst=0, // D.body.scrollTop/Left
areaWidth,areaHeight, // client canvas / "squares" div size
asyncCommands={}, // Set of POST commands to be sent by next call to sendEvents function
leftClicked, // Set to 1 when a left click has been performed, used to detect double clicks and adapt events sending
canvasDrawError=0, // Set to > 0 on canvas draw error, used to request a full-screen refresh on error
keybMenuShown=0, // Set to 1 when mobile keyboard input menu is shown, used to avoid showing alt click menu when clicking on screen
updatePaused=0; // Set to 1 to pause events / canvas update (used by remote desktop while typing)


/******************************************************************************
 * Misc functions
 *****************************************************************************/
function stopLoading(){
	windowStop();
	var n,i=0;
	while(n=dgi("sq"+i)) {imgBuff[i].src=n.src="/gfx/v.gif";i++}
}

/**
 * Set mouse in or out of window
 */
function winMouseIn(){mouseIn=1;resumeFocus(1)}
function winMouseOut(){mouseIn=0;resumeFocus(0)}

/**
 * Start / Stop focussing on keys2 input to get keyboard events
 */
function resumeFocus(f){
	if(altClick) return; // Never use keys2 focus with alternate click menu
	// Resume focussing
	if(f && !focusInterval && !focusIntervalSuspended && dgi('keys2')){
		focusInterval=setInterval("dgi('keys2').focus()",100);
	}
	// Stop focussing
	if(!f && focusInterval){
		clearInterval(focusInterval);
		focusInterval=0;
	}
}

// Set inputBox and controlBox dimensions so content fit (WA)
function inputBoxesResetSize(){
	if(winMe.addControls || !dd.elements.controlBox) return;
	dd.elements.controlBox.resizeTo(actualOffsetRight(dgi("controlBoxLE"))-actualOffsetLeft(dgi("controlBox"))+10,false);
	dd.elements.inputBox.resizeTo(actualOffsetRight(dgi("inputBoxLE"))-actualOffsetLeft(dgi("inputBox"))+10,false);
}
function unprotect(str){return str.replace(/&amp;/gi,"&").replace(/&lt;/gi,"<").replace(/!weezobr!/gi,String.fromCharCode(10))}
function protect(str){return str.replace(/[\/]/gi,"*weezoslash*").replace(/[&]/gi,"*weezoamp*")}

// Window minimized or state changed
function winStateChanged(prev,current){
	winState=current;
	if(current=='minMax' || current=='minNormal') {
		winMouseOut();
	}
	else refreshASAP=0;
}
function clearMouseIcons(){dgi("mouseIcons").innerHTML='';}
function blink(eltName,times,action){
	if(!action) action="hide";
	if(winMe.addControls) elts=parent.D.getElementsByName(eltName);
	else elts=D.getElementsByName(eltName);
	for(var i=0;i<elts.length;i++){
		if(action=="hide") elts[i].style.visibility="hidden"; else elts[i].style.visibility="visible";
	}
	if(action=="hide") setTimeout('blink("' + eltName + '", ' + times + ', "show")',100);
	else {
		if((times--)>0) setTimeout('blink("' + eltName + '", ' + (times) + ', "hide")',100);
	}
}


// Show / Hide input box (used on standalone window)
function toggleInputBox(){
	if(displayInputBox=!displayInputBox) {
		dd.elements.inputBox.moveTo(dd.elements.controlBox.x, dd.elements.controlBox.y);
		dd.elements.controlBox.moveTo(-1000,-50);
		sendData("displayInputBox=1");
	}
	else{
		dd.elements.controlBox.moveTo(dd.elements.inputBox.x, dd.elements.inputBox.y);
		dd.elements.inputBox.moveTo(-1000,-50);
		sendData("displayInputBox=0");
	}
	focusKeyInput();
}
// Return usable window inner width & height
function getInnerWidth(){return (W.fixedAreaWidth)?fixedAreaWidth:winMe.getInnerWidth()}
function getInnerHeight(){return (W.fixedAreaHeight)?fixedAreaHeight:winMe.getInnerHeight()}

// Change zoom to 1:1 ratio (type='restore') or to adjust/fit screen (type='adapt')
function changeZoomType(type){
	// Canvas method
	if(wl.rVar.screenUpdateMethod=='canvas'){
		adaptZoom=(type=='adapt')
		addCommand('zoomType',type);
		winResized();
		refreshASAP=1;
	}
	else {
		stopLoading();
		fAS('',type,getInnerWidth(),getInnerHeight());
	}

}

/**
 * Mobile manual zoom in/out, used on android devices as a workaround to impossibility to guess zoom level. Called by acZoomIn / acZoomOut buttons
 * Fix things by simulating viewport innerWidth to what it should be
 * @param string z: 'in' or 'out'
 */
/*
function zoomFix(z){
	var pw=fixedAreaWidth, ph=fixedAreaHeight;
	var zf=zoomFixComp(z);
	fixedAreaWidth=zf['w'];
	fixedAreaHeight=zf['h'];
	//cfDbg(pw+'x'+ph+'=>'+fixedAreaWidth+'x'+fixedAreaHeight)
	changeZoomType('adapt'); // Sync reload page to update server-side zoom
}
*/
/**
 * Mobile manual zoom in/out: compute and return new zoom values
 * @param string z: 'in' or 'out'
 * @return array {'w':,'h':}
 */
/*
function zoomFixComp(z){
	var nw=fixedAreaWidth,nh=fixedAreaHeight;
	nh*=(z=='out')?0.5:2;
	nh=Math.min(nh,2*monH); nh=Math.max(nh,Math.max(clientWidth,clientHeight));
	return {'w':Math.floor(monW*nh/monH),'h':Math.floor(nh)}
}
*/


// Select screen
function setScreen(nb){
	stopLoading();
	fAS(nb,'setScreen',getInnerWidth(),getInnerHeight(),'sync');
}

// Set a mask over area if mouse is being moved over controls input area
function fadeMask(){
	if(dd.ie) dgi("mask").style.filter="Alpha(opacity=50, style=0)"; else dgi("mask").style.background="url('/gfx/w50.png')";
	maskFaded=1;
	resumeFocus(0);
	focusIntervalSuspended=1;
}
function showMask(){
	if(inputBoxDragInProgress) return;
	var s=dgi("mask").style;
	if(dd.ie) s.filter="Alpha(opacity=1, style=0)"; else s.background="transparent";
	maskFaded=0;
	focusIntervalSuspended=0;
	resumeFocus(1);
	inputBoxFocused=false;
}

/******************************************************************************
 * Redraw updated squares
 * str: string of nbSquaresX*nbSquaresY 0 or 1 depending if square must be updated. Leave empty to update all (sync call)
 *****************************************************************************/
function updateSquares(str){
	if(wl.rVar.screenUpdateMethod=='canvas') return updateCanvas(str);

	// 1st sync call: update all squares
	if(!str){
		for(var i=0; i<squaresNb; i++) dgi("sq"+i).src=PHP_SELF+'?img='+i+'&rnd='+Math.random();
		return;
	}
	for(var i=0; i<squaresNb; i++){
		if(str.substr(i,1)!=0) {
			imgBuff[i].src=PHP_SELF+'?img='+i+'&rnd='+Math.random();
			/*
			if(debug) {
				dgi("sq"+i).className="debugSquare";
				//dgi("dbgSq"+i).style.color="red";
				//dgi("dbgSq"+i).innerHTML=str.substr(i,1);
			}
			*/
		}
	}
}

// Canvas node and canvas drawing context, image used to load mask before drawing on canvas, mask string (0-1 depending on updated parts)
var maskCanvas,maskCtx,maskImg=new Image(),maskSeqNb=0;
var maskImgLoaded,maskImgLeft,maskImgTop,
maskSqX, // Number of columns in canvas update image
maskSqY, // Number of rows    in canvas update image
screenshotWidth, // width in pixels of screenshot (monitor width * server-side zoom)
screenshotHeight, // height in pixels of screenshot (monitor height * server-side zoom)
maskM; // Mask matrix


/**
 * Update display using mask method
 * @param str: [nbSqX]x[nbSqY]/[compressed result string]
 */
function updateCanvas(str){
	maskImgLoaded=0; // Indicate an image will start loading, so no screen refresh will be requested until it is actually loaded
	var ss=maskSquaresSide,res,i,x,y;

	// Init
	if(!maskCtx){
		maskCanvas=dgi('maskCanvas');

		// If canvas not supported, reload with squares method
		if(!maskCanvas.getContext) return wl.goURL('?unsupportedCanvas');
		maskCtx=maskCanvas.getContext('2d');

		// On squares image load ("this" is image)
		maskImg.onload=function(){setTimeout("maskImageLoaded(0)",1)} // Set a timeout as sometime onload event seems to be fired before image is actually ready
		maskImg.onerror=function(){maskImgLoaded=1;maskSeqNb++}
	}

	// 1st load: no need to generate update matrix
	if(!str) {
		// Start loading full-screen image
		maskImg.src=PHP_SELF+'?readOnlySession&mask='+Math.random();
		return;
	}


	// Retreive screenshot dimensions
	res=str.substr(0,str.indexOf('/')).split('x');
	screenshotWidth=res[0]; screenshotHeight=res[1];

	str=str.substr(str.indexOf('/')+1)
	var s=str.substr(str.indexOf('/')+1).split(':'),l=s.length

	// Retreive number of vertical and horizontal squares
	res=str.substr(0,str.indexOf('/')).split('x');
	maskSqX=res[0]; maskSqY=res[1];

	// Decompress update string
	c=0; pos=0; maskImgLeft=maskSqX; maskImgTop=maskSqY; maskImgRight=-1; maskImgBottom=-1; maskM={};
	//maskCtx.fillStyle = "rgba(255,255,255,0.2)";

	for(i=0;i<l;i++) {
		len=s[i]; if(len==='') len=1;
		for(;len>0;len--) {
			x=pos%maskSqX;
			y=Math.floor(pos/maskSqX);
			if(y==0) maskM[x]={};
			maskM[x][y]=c;
			pos++;
			if(c){
				//maskCtx.fillRect(x*ss,y*ss,ss,ss)
				if(x<maskImgLeft)	maskImgLeft=x;
				if(x>maskImgRight)	maskImgRight=x;
				if(y<maskImgTop)	maskImgTop=y;
				if(y>maskImgBottom)	maskImgBottom=y;
			}
		}
		c=1-c;
	}

	// Start loading image (except if nothing has been modified)
	if(maskImgRight!=-1) maskImg.src=PHP_SELF+'?readOnlySession&mask='+Math.random(); else maskImgLoaded=1;
}

/**
 * Draw loaded mask image on canvas
 * @param retry: number of retries on drawing this image: sometime image doesn't seems to be ready for drawing when firing onload event => retry a max of 3 times
 */
function maskImageLoaded(retry){
	var ss=maskSquaresSide,sx,sy,c,srcTop,srcLeft,srcWidth,srcHeight,nb,w,h,maskImgOffsetX=maskImgLeft*ss,maskImgOffsetY=maskImgTop*ss;


	maskImgLoaded=1;
	maskSeqNb++;
	canvasDrawOk=canvasDrawError=0;

	// Update canvas size according to area theorical width & height (except for fixedSquares where canvas has a constant size (1:1 source screen)
	if(!fixedSquares){
		if(maskCanvas.width!=areaWidth) maskCanvas.width=areaWidth;
		if(maskCanvas.height!=areaHeight) maskCanvas.height=areaHeight;
	}

	// 1st image load: just copy it on entire canvas
	if(maskSeqNb==1) {
		maskCtx.drawImage(maskImg,0,0,maskImg.width,maskImg.height,0,0,maskCanvas.width,maskCanvas.height);
		//alert('redraw w='+maskCanvas.width+' h='+maskCanvas.height)
		return;
	}

	// fixed squares: adjust destination size to full monitor size
	if(fixedSquares) zr=monW/screenshotWidth; else zr=1;

	// Else just draw updated squares

	// Browse source image. sx and sy are in canvas squares coordinates
	for(sy=maskImgTop;sy<maskImgBottom+1;sy++){
		nb=0;
		for(sx=maskImgLeft;sx<maskImgRight+1;sx++){
			if(maskM[sx][sy]==1){
				if(nb==0){
					srcLeft=sx*ss;
					srcTop=sy*ss;
					destLeft=sx*monW/ss;
					destTop=sy*monH/ss;
				}
				nb++;
			}
			else if(nb>0){
				srcW=Math.min(Math.min(nb*ss,areaWidth-srcLeft-1),maskImg.width+maskImgOffsetX-srcLeft-1);
				srcH=Math.min(Math.min(ss,areaHeight-srcTop-1),maskImg.height+maskImgOffsetY-srcTop-1);

				try{
					maskCtx.drawImage(maskImg, srcLeft-maskImgOffsetX, srcTop-maskImgOffsetY, srcW, srcH, srcLeft*zr, srcTop*zr, srcW*zr, srcH*zr);
					canvasDrawOk++;
				}
				catch(e){
//					cfDbg('dest:(topleft point in dest canvas:'+(srcLeft)+'x'+(srcTop)+' bottomright:'+(srcLeft+w)+'x'+(srcTop+h)+' blocksize:'+w+'x'+h+')<br>',1);
//					maskCtx.fillStyle = "rgba(0,0,255,0.4)";
					canvasDrawError++;
				}
				nb=0;
			}
		}
		srcW=Math.min(Math.min(nb*ss,areaWidth-srcLeft-1),maskImg.width+maskImgOffsetX-srcLeft-1);
		srcH=Math.min(Math.min(ss,areaHeight-srcTop-1),maskImg.height+maskImgOffsetY-srcTop-1);

		try{
			if(nb>0) maskCtx.drawImage(maskImg, srcLeft-maskImgOffsetX, srcTop-maskImgOffsetY, srcW, srcH, srcLeft*zr, srcTop*zr, srcW*zr, srcH*zr);
			canvasDrawOk++;
		}
		catch(e){
//cfDbg('++src:(width='+this.width+' height='+this.height+' topleft:'+(srcLeft-maskImgOffsetX)+'x'+(srcTop-maskImgOffsetY)+' bottomright:'+(srcLeft-maskImgOffsetX+w)+'x'+(srcTop-maskImgOffsetY+h)+' blocksize:'+w+'x'+h+')<br>',1);
//cfDbg('>>> (topleft:'+(srcLeft)+'x'+srcTop+', bottomright:'+(srcLeft+w)+'x'+(srcTop+h)+'  blocksize='+(w)+' height='+(h)+' area:'+areaWidth+'x'+areaHeight+') err:'+e+'<br>',1);
			canvasDrawError++;
//			maskCtx.fillStyle = "rgba(0,0,255,0.4)";
//			maskCtx.fillRect(srcLeft*zr, srcTop*zr, srcW*zr, srcH*zr);
		}
	}

	if(canvasDrawError>0) {
		//cfDbg(canvasDrawError+"errors ("+canvasDrawOk+' OK) retry nb='+retry,1);
		// Retry up to 3 times with a timeout to let time to image
		if(++retry<3){
			canvasDrawError=0;
			setTimeout('maskImageLoaded('+retry+')',50);
		}
		// Else let canvasDrawError>0 so a full screen refresh is requested
	}

	// Webkit memory leak WA (fixed in 2.1.0R with no-store header removal)
	//if(phpBrowser=='webkit' && maskSeqNb%60==0) wl.postData({'noDownScale':1});
}



/**
 * @desc Function called when buffer image loaded => replace shown image src with this
 */
function imgBuffLoaded(){dgi("sq"+this.alt).src=this.src}

// If screen should be stretched to fit window, update squares size & position
function winResized(){
	var x,y,sw,sh,r=monW/monH,s=dgi('squares').style,bs=D.body.style,offY=dgi('squares').offsetTop;
	if(!maskCanvas) maskCanvas=dgi('maskCanvas');

	areaWidth=getInnerWidth();
	areaHeight=getInnerHeight();

	// Fixed squares size (iPhone/Android): don't update squares size, inverse zoom computation
	if(fixedSquares) zoom=1;
	else{
		// Fit screen to window: compute screen dimensions keeping ratio
		if(adaptZoom) {
			if(!W.fixedAreaHeight){
				if(areaWidth/areaHeight>r) areaWidth=Math.ceil(areaHeight*r); else areaHeight=Math.ceil(areaWidth/r);
				zoom=areaWidth/monW;
			}
			// Forbid desktop stretching
			if(zoom>1){
				areaWidth=monW;
				areaHeight=monH;
				zoom=1;
			}
		}
		// 1:1 display: keep server-side screen size
		else {
			areaWidth=monW;
			areaHeight=monH;
			zoom=1;
		}
		// Reset body and "squares" div sizes
		s.width  = bs.width = areaWidth+'px';
		s.height = bs.height = areaHeight+'px';
	}

	// Update squares positions
	if(wl.rVar.screenUpdateMethod=='squares'){
		sw=Math.floor(areaWidth/squaresX); sh=Math.floor(areaHeight/squaresY);

		// force constant square position & size for not-resizable screen (mobiles (iOS))
		if(fixedSquares){
			sw=monW/squaresX;
			sh=monH/squaresY;
			s=dgi('mask').style;
			s.top=offY+'px';
			//s.width=monW+'px';
			//s.height=monH+'px';
		}
		for(x=0;x<squaresX;x++){
			for(y=0;y<squaresY;y++){
		 		s=dgi("sq"+(x+y*squaresX)).style;
		 		s.left=(x*sw)+'px';
		 		s.top=(offY+y*sh)+'px';
		 		if(s.width!=sw+'px'){
		 			s.width=sw+'px';
		 			s.height=sh+'px';
		 		}
		 		//s.width='auto';
		 		//s.height='auto';
		 		//s.border='1 px solid red'
			}
		}
	}
	// Update canvas dimensions
	else {
		var s=maskCanvas.style;
		s.width=((fixedSquares)?monW:areaWidth)+'px';
		s.height=((fixedSquares)?monH:areaHeight)+'px';
	}

	// Set alt click menu size and position if shown
	if(altClickMenuShown) altClickSetMenu(0);

	// Refresh content ASAP if resized
	if(adaptZoom) refreshASAP=1;
}


// Set mouse position and modifier keys states
function setState(e){
	// World
	if (e && e.pageX!=undefined) {
		XX=e.pageX;
		YY=e.pageY;
	}
	// IE
	else {
		XX=event.x+D.body.scrollLeft;
		YY=event.y+D.body.scrollTop;
	}
}

/******************************************************************************
 * Mouse & keyboard Events
 *****************************************************************************/

// Add event to events buffer
function addEvent(evt){
	var isMouseMove=(evt.substr(0,3)=="mmv")

	// Don't send mouse move if mouse is out of screen area
	if(!mouseIn && isMouseMove) return;
	if(isMouseMove && evt.indexOf('undefined')!=-1) return;
	mixedEvents+=((mixedEvents.length>0)?'/':'')+evt;

	// Update last event time
	if(!isMouseMove) lastEventTime=wl.chrono.microtime();
}
// Replace last event keycode by "keypressed"
function fixEventKC(oldKc,newKc){
	var m=mixedEvents,p=m.lastIndexOf('kd;'+oldKc+';'),offset=("kd;;"+oldKc).length;
	if(p==-1) return;
	m=m.substr(0,p)+'kad;'+newKc+';'+m.substr(p+offset);
	mixedEvents=m;
}

/**
 * Add a POST command=value to next sendEvents call
 * @param command: command key
 * @param value: payload
 */
function addCommand(command,value){asyncCommands[command]=value}


/******************************************************************************
 * Mouse Events
 *****************************************************************************/

// IE
function watchScrollBars(){
	if(D.body.scrollLeft==dbsl && D.body.scrollTop==dbst) return;
	dbsl=D.body.scrollLeft ;
	dbst=D.body.scrollTop;
	var s=dgi("keys2div").style;
	s.left=(dbsl+D.body.offsetWidth/2)+"px";
	s.top=(dbst+D.body.offsetHeight/2)+"px";
}

/**
 * Update mouse coordinates, and position elements according to mouse position
 */
var updateMousePosMT=0;
function updateMousePos(e){
	setState(e);
	var s,n;
	if(n=dgi("nStatus")){
		n.style.left=(XX+15)+"px";
		n.style.top=(YY)+"px";
	}
	if(n=dgi("keys2div")){
		n.style.left=(D.body.scrollLeft+winMe.getInnerWidth()/2)+"px";
		n.style.top=(D.body.scrollTop+winMe.getInnerHeight()/2)+"px";
	}
	XX=Math.round(XX*1.0/zoom);
	YY=Math.round(YY*1.0/zoom);

	// Draw selection blue box
	if(maskDragInProgress && dd.obj && dd.obj.name=="mask") {
		var sel=dgi("select").style;
		if(startX>XX) {sel.left=XX*zoom; sel.width=(startX-XX)*zoom;} else {sel.left=startX*zoom; sel.width=(XX-startX)*zoom;}
		if(startY>YY) {sel.top=YY*zoom; sel.height=(startY-YY)*zoom;} else {sel.top=startY*zoom; sel.height=(YY-startY)*zoom;}
		sel.display="block";
	}
	// Update server-side mouse position
	if(!altClick){
		var t=wl.chrono.microtime();
		if(t-updateMousePosMT > 50) {
			updateMouseEvents(e);
			updateMousePosMT=t;
		}
	}
}

/**
 * Add a mouse event
 * @param ev: DOM event
 */
function updateMouseEvents(ev){
	var action,im,prevAction=W.prevAction;
	if(maskFaded||!ev) return;

	//if(ev.type!='mousemove') cfDbg(ev.type)

	// If updateMouseEvents is called by oncontextmenu() but browser already sends right clicks to onmousedown&up functions, discard
	if(ev.type=='contextmenu' && W.receiveRightClicks) return;

	// If action is left, right or middle clic event
	if(ev.type=='mousedown'||ev.type=='mouseup'||ev.type=='contextmenu'){
		action='l';
		if(ev.button==2 || ev.type=='contextmenu') {
			action='r';
			if(ev.type!='contextmenu') W.receiveRightClicks=1;
		}
		if(ev.button==4) action='m';
		im=(action=='r' || action=='m');
		action+=((ev.type=='mousedown' || ev.typeWA=='mousedown')?'d':'u');

		if(ev.type=='mouseup'){
			if(im||leftClicked) refreshASAP=1;
			else leftClicked=1;
		}

	}
	// Mouse wheel up or down
	else if(ev.type=='mousewheel' || ev.type=='DOMMouseScroll'){
		if(D.body.offsetHeight<monH*zoom && !adaptZoom) return;
		action=(ev.wheelDelta>0 || ev.detail<0)?'wu':'wd';
	}
	// Mouse wheel up or down
	else if(ev.type=='mousemove') action='mv';
	else return;

	// Display mouse click icon
	if(action!='mv' && wl.rVar.screenUpdateMethod!='canvas') {
		dgi("mouseIcons").innerHTML+='<img style="position:absolute;top:'+(YY*zoom-16)+'px;left:'+(XX*zoom-16)+'px;" src="'+imgCache[action.substr(0,1)].src+'">';
		// Set mouseIcons layer below mask layer
		var t,e;
		for(t in {'mask':1,'inputBox':1,'controlBox':1,'clipboardBox':1}) if(e=dd.elements[t]) e.maximizeZ();
	}

	// Double click pb on IE/squares: simulate mouse down as second click mouse down is not fired
	if(action=='lu' && prevAction=='lu') addEvent("m"+"ld"+";"+XX+";"+YY+";"+((ev.altKey)?'a':'')+((ev.ctrlKey)?'c':'')+((ev.shiftKey)?'s':''));
	W.prevAction=action;

	// Send event
	addEvent("m"+action+";"+XX+";"+YY+";"+((ev.altKey)?'a':'')+((ev.ctrlKey)?'c':'')+((ev.shiftKey)?'s':''));

	return true;
}

// Mouse down on mask (start dragging)
function preDrag(){
	if(altClick) return;

	if(dd.obj.name=="mask" && wl.rVar.screenUpdateMethod=='squares'){
		startX=XX; startY=YY;
		maskDragInProgress=1;
		var sel=dgi("select").style; sel.left=XX*zoom; sel.top=YY*zoom; sel.height=0; sel.width=0; sel.display="block";
	}
	if(dd.obj.name=="inputBox" || dd.obj.name=="controlBox" || dd.obj.name=="clipboardBox") inputBoxDragInProgress=1;
	focusKeyInput();
}

// Mouse up on mask (done dragging)
function preDrop(){
	maskDragInProgress=false;
	dgi("select").style.display="none";
	if(dd.obj.name=="inputBox" || dd.obj.name=="controlBox" || dd.obj.name=="clipboardBox") inputBoxDragInProgress=0;
	else {
		//if(dd.e.button>1) updateMouseEvents("ru"); else	updateMouseEvents("lu");
	}
}


/******************************************************************************
 * Keyboard events
 * called onkeyup & down on document and #key input
 * e: event
 * forceFromKeyb: true to process even if mask is not shown, and not to focus on keys2
 * fakeKeyPress: true to simulate a key up / down (mobile, called onkeyup)
 *****************************************************************************/
function keyAddSeq(e,forceFromKeyb,fakeKeyPress){
	// If mask is shown, don't process
	if(maskFaded && !forceFromKeyb) return;
	if(!e) e=W.event;

	var nkc,kc=(e.which)?e.which:e.keyCode;

	// Fix key up & down codes by keypress value
	if(keypressFix && kc!=16 && kc!=17 && kc!=18){
		// Key down event: store (potentially wrong) keycode for ulterior matching
		if(e.type=='keydown'){
			keypressFix.downKC=kc
			keypressFix.ts=wl.chrono.microtime();
		}
		// Keypress event: right key code sent: store (for upcoming keyup) and replace key code for last keydown event
		else if(e.type=='keypress' && (wl.chrono.microtime()-keypressFix.ts < 5) && keypressFix.downKC!=kc){
			keypressFix.list[keypressFix.downKC]=kc;
			fixEventKC(keypressFix.downKC, kc);
		//	cfDbg('fix '+keypressFix.downKC+' -> '+kc)
		}
		// Keyup: replace by fix, and remove from array (as many keys may have the same keydown kc)
		else if(e.type=='keyup' && keypressFix.list[kc]){
			nkc=keypressFix.list[kc];
			delete(keypressFix.list[kc]);
			kc=nkc;
		}
	}

	// add to pending events string
	if(e.type!='keypress') addEvent('k'+((nkc)?'a':'')+((e.type=='keyup'||fakeKeyPress)?'u':'d')+';'+kc+';'+((e.altKey)?'a':'')+((e.ctrlKey)?'c':'')+((e.shiftKey)?'s':''));
	if(fakeKeyPress) addEvent('k'+((nkc)?'a':'')+'d'+';'+kc+';'+((e.altKey)?'a':'')+((e.ctrlKey)?'c':'')+((e.shiftKey)?'s':''));

	if(!forceFromKeyb) dgi('keys2').focus();
	stopPropagation(e);

	return false;
}


/**
 * Send keys from keys input box
 */
function sendKeys(){
	var cont;
	if(winMe.addControls) cont=parent; else cont=W;
	if(cont.dgi("keys").value.length==0) return;
	addEvent("mmv;"+XX+";"+YY+";");
	addEvent("ks"+cont.dgi("keys").value);
	cont.dgi("keys").value="";
	refreshASAP=1;
}
// Clear keys input box
function clearKeys(){
	var cont=(winMe.addControls)?parent:W;
	cont.dgi("keys").value="";
}
// Insert special key from dropdown list
function insertKey(){
	var cont;
	if(winMe.addControls) cont=parent; else cont=window;

	if(cont.dgi("specialKeySelect").value=='Cancel') return;
	cont.dgi("keys").value+=cont.dgi("specialKeySelect").value;
	cont.dgi("keys").focus();
	cont.dgi("specialKeySelect").value='Cancel';
}
function focusKeyInput(){
	if(maskFaded || displayInputBox || clipboardBoxFocused) return resumeFocus(0);
	dgi("keys2").focus();
}
// Called onfocus from winbar
function focusKeys(){inputBoxFocused=1}






/******************************************************************************
 * Clipboard management
 *****************************************************************************/

function sendClipboard(clipboardContent){
	if(phpBrowser=='ie'){
		if(typeof clipboardData != 'undefined') {
			addEvent("mmv;"+XX+";"+YY+";");
		    addEvent("cp"+protect(clipboardData.getData("Text")));
		    refreshASAP=1;
		    blink("clipboardOutBt",1);
		}
		else alert(wl.capt.clipboardNoData);
	}
	else{
		if(!clipboardContent){
			showSendClipboardBox();
		}
		else{
			clipboardContent=dgi("clipboardText").value;
			addEvent("mmv;"+XX+";"+YY+";");
			addEvent("cp"+protect(clipboardContent));
			refreshASAP=1;
			blink("clipboardOutBt",1);
			closeClipboardBox();
		}
	}
}
function requestClipboard(){
	addEvent("cg");
	refreshASAP=1;
	blink("clipboardInBt",1);
}
function downloadClipboardFiles(){fAS('','downloadClipboardFiles');}
function pasteInLocalClipboardIE(data){
	dgi("clipboardText").innerText = unprotect(data);
	var tr = dgi("clipboardText").createTextRange();
	tr.execCommand("RemoveFormat");
	tr.execCommand("Copy");
	blink("clipboardInBt",3);
}
function resetClipboardBox(){dgi("clipboardText").value ="";}
function addToClipboardBox(data){dgi("clipboardText").value+=data;}
function pasteInLocalClipboard(data){
	dgi("clipboardText").value=unprotect(data);
	dgi("clipboardText").select();
	showGetClipboardBox();
	blink("clipboardInBt",3);
}
function closeClipboardBox(){
	clipboardBoxFocused=0;
	dgi("clipboardText").value='';
	dd.elements.clipboardBox.moveTo(-1000,50);
}
function showGetClipboardBox(){
	dgi("clipboardSendBt").style.display='none';
	dgi("clipboardCaptionRequest").style.display='inline';
	dgi("clipboardCaptionSend").style.display='none';
	dgi("clipboardCaptionPaste").style.display='none';
	dgi("clipboardText").focus();
	dd.elements.clipboardBox.maximizeZ();
	dd.elements.clipboardBox.moveTo(20,50);
}
function showSendClipboardBox(){
	dgi("clipboardSendBt").style.display='block';
	dgi("clipboardCaptionRequest").style.display='none';
	dgi("clipboardCaptionSend").style.display='inline';
	dgi("clipboardCaptionPaste").style.display='inline';
	dgi("clipboardText").focus();
	dd.elements.clipboardBox.maximizeZ();
	dd.elements.clipboardBox.moveTo(20,50);
}



/******************************************************************************
 * Alt click management (mobiles)
 *****************************************************************************/


// Show, move and resize (if width is set) target
function altClickTargetShow(x,y,width){
	var t=$('target'),ts=t.style;
	// Resize & Position target element
	if(width){
		ts.width=(width)+'px';
		ts.height=(width)+'px';
	}
	else width=t.offsetWidth;
	ts.left=(x-width/2)+'px';
	ts.top=(y-width/2)+'px';
}
// Hide target
function altClickTargetHide(){dgi('target').style.left='-2000px'}

// Set alt click menu position and size
// Called by altClickShowMenu and on window resize
// set updateTargetPosition to update target position from mouse click, or set to 0 only to update menu size (called by winResized when menu is shown)
function altClickSetMenu(updateTargetPosition){
	var abs,ab,iw,cw,ch;
	cw=(fixedArea)?clientWidth:W.innerWidth;
	ch=(fixedArea)?clientHeight:W.innerHeight;

	if(!fixedArea) iw=18/wl.viewportZoom(); else iw=cw/24;

	// Position menu (bx, by = topleft x,y menu position)
	var bx=W.pageXOffset + 4*iw, /*W.pageXOffset + W.innerWidth/2 - iw*/
		by=W.pageYOffset + 4*iw;

	// If target is on the left-side of screen, put menu on the right
	if(altClickX-iw<W.pageXOffset + cw/2) bx+=cw-11*iw;

	// Verticaly center menu
	by+=ch/2-8*iw;
	by=Math.max(by,W.pageYOffset+3.5*iw)

	// Update target position
	if(updateTargetPosition) altClickTargetShow((updateTargetPosition)?mouseX:altClickX,(updateTargetPosition)?mouseY:altClickY,2*iw)

	// Send mouse move event on target move
	addEvent('mmv;'+altClickX+';'+altClickY+';');

	// If menu is already shown, just move target
	if(altClickMenuShown && updateTargetPosition) return;

	var pos={'acLc':[-3,-3],'acDbl':[0,-3],'acRc':[3,-3],'acDrag':[-3,0],'acMv':[0,0],'acCancel':[0,3],'acHome':[-3,3],'acKb':[3,0],'acZoomIn':[-3,-6],'acZoomOut':[3,-6]}


	// Resize and position buttons
	for(var i=0;i<dgn('acBt','all').length;i++){
		ab=dgn('acBt',i);
		ab.className='acBt';
		abs=ab.style;

		// Remove zoom in/out button if zoom is at max or min leven
		if(ab.id=='acZoomIn') abs.display=(2.0*zoomFixComp('in')['w']==2.0*fixedAreaWidth)?'none':'';
		if(ab.id=='acZoomOut') abs.display=((2.0*zoomFixComp('out')['h'])==2.0*fixedAreaHeight)?'none':'';
		//if(ab.id=='acZoomOut'||ab.id=='acZoomIn') cfDbg(ab.id+'>'+abs.display);

		if(ab.id!='acLc' && ab.id!='acRc'){
			abs.padding=(iw/4)+'px';
			ab.firstChild.style.width=(2*iw)+'px'; ab.firstChild.style.height=(2*iw)+'px';
		}
		else{
			abs.padding=(iw/2)+'px';
			ab.firstChild.style.width=(3*iw/2)+'px'; ab.firstChild.style.height=(3*iw/2)+'px';
		}
		abs.zIndex=1001;
		abs.borderWidth=Math.max(1,iw/20)+'px';

		// Position buttons
		var screenOffset=0; // Used for shifting position of screen selection button(s) (as number is unknown)
		if(pos[ab.id]){
			ofx=iw*pos[ab.id][0];
			ofy=iw*pos[ab.id][1];
		}
		// Other screen(s) button(s)
		else{screenOffset++;ofx=iw*3;ofy=iw*3}

		// Set position
		abs.left=(bx+ofx)+'px'; abs.top=(by+ofy)+'px';
	}

	// Resize & Position controls box
	ofx=-3*iw;ofy=3*iw;
	var snodes=dgi('acText').firstChild;
	var fs=iw+'px';
	//ats.fontSize=iw;
	//dgi('acTxtInput').style.fontSize=iw*0.6;
	//dgi('acKeySelect').style.fontSize=iw*0.6;

	while (snodes!=undefined && snodes!=null) {
		if(snodes.style) snodes.style.fontSize='30px';
		snodes=snodes.nextSibling;
	}
}

/**
 * Show alt click menu
 */
function altClickShowMenu(e){
	e=(e)?e:W.event;
	var t=e.src; if(!t) t=e.target;

	if(keybMenuShown || mouseY<dgi('squares').offsetTop) return;

	// Update mouse position (only if click is on mask or on a square, not on menu)
	if(t.id=='mask'||t.id.substr(0,2)=='sq'){
		updateMousePosition(e); // Retreive mouse X & Y
		updateMousePos(e); // Move some elements
		altClickX=Math.round(mouseX*1.0/zoom);
		altClickY=Math.round(mouseY*1.0/zoom);
	}
	else return true;


	// If we're on a double click sequence, consider this event a second clic
	if(altClickDragInProgress) {altClickAction('DragDrop'); return;}

	// Set menu and target size and position
	altClickSetMenu(1);

	altClickMenuShown=1;
}

// Hide mobile alt click menu
function altClickHideMenu(){
	for(var i=0;i<dgn('acBt','all').length;i++) dgn('acBt',i).style.left='-2000px';
	altClickTargetHide();
	altClickMenuShown=0;
}

// Show mobile keyboard menu
function keybShowMenu(){
	altClickHideMenu();

	if(isMobile) W.updatePaused=1; // Stop events / canvas refresh

	// Resize buttons
	var iw=24/wl.viewportZoom(),ab,s;

	for(var i=0;i<dgn('keybBt','all').length;i++){
		ab=dgn('keybBt',i);
		s=ab.style;	s.position='relative'; s.left=0; s.top=0;
		s.display='inline-block';
		s.padding=Math.floor(iw/8)+'px';
		//ab.style.padding=(iw/4)+'px';AAaAaaZZ

		ab.firstChild.style.width=(1.4*iw)+'px'; ab.firstChild.style.height=(1.4*iw)+'px';
	}
	s=dgi('acText').style;
	s.position='absolute';
	s.width=getInnerWidth()+'px';
	s.height=(iw*1.2)+'px';
	s.top=W.pageYOffset+'px'; s.left=W.pageXOffset+'px';
	dgi('acTxtInput').focus();
	s.top=W.pageYOffset+'px'; s.left=W.pageXOffset+'px';


	keybMenuShown=1;
	W.keybMenuTimer=setInterval(keybWatch,100);
}
// Hide mobile keyboard menu
function keybHideMenu(onlyIfNotFocused){
	if(onlyIfNotFocused && dgi('acTxtInput').hasFocus) return;

	clearInterval(W.keybMenuTimer);
	keybMenuShown=0;
	dgi('acText').style.top='-2000px';
	if(isMobile) {
		W.updatePaused=0;
		keybWatch();
	}
}
// Watch mobile keyboard input changes (called by interval, set on keybShowMenu). If changes detected, send to server
function keybWatch(){
	if(browserOS=='Android' && W.updatePaused) return; // On android devices, only apply function on text input blur, to avoid stacking words being typed

	var k=dgi('acTxtInput'),t=wl.chrono.microtime();

	//var m=((dgi('acShift').checked)?'{+}':'')+((dgi('acCtrl').checked)?'{^}':'')+((dgi('acAlt').checked)?'{%}':'');
	if(!k.value) return;

	// Protect \ and {
	if(k.value=='\\'||k.value=='{') k.value='\\'+k.value;
	addEvent("ks"+protect(k.value));
	k.value='';

	// Delay before sending event
	lastEventTime=lastResponseTime=t+100;
}
// Mobile keyboard onkeyup: process special keys (backspace and return) and escape \ and { with a \
function keybKU(e,n){
	var kc=e.keyCode;
	// Backspace or return
	if(kc==8||kc==13){n.value='';keyAddSeq(e,1,1)}

	// "\" or "{": escape with '\'
	if(kc==95||kc==39) {
		var v=n.value,l=v.length;
		v=n.substr(0,l-1)+'\\'+n.substr(l-1);
	}
}

// Called when a special keyboard key button is pressed
function keybAction(k){
	dgi('acTxtInput').value=k;dgi('acTxtInput').focus();
}

/**
 * Called on altClick menu button clicked
 * @param string action: action name
 * @param event e
 */
function altClickAction(action,n){
	if(dgi('ac'+action)){
		dgi('ac'+action).className='acBt acBtSel';
		setTimeout(function(){dgi('ac'+action).className='acBt'},200);
	}
	var e=W.event;mod=((dgi('acShift').checked)?'+':'')+((dgi('acAlt').checked)?'%':'')+((dgi('acCtrl').checked)?'^':'');
	var cx=Math.round(mouseX*1.0/zoom), cy=Math.round((mouseY-actualOffsetTop(dgi('squares')))*1.0/zoom);

	switch(action){
		case 'Drag':
			altClickDragInProgress=1;
			altClickHideMenu();
			W.dragPickX=altClickX;
			W.dragPickY=altClickY;
			return;
		case 'Kb':
			keybShowMenu();
			return;
		case 'DragDrop':
			altClickDragInProgress=0;
			addEvent('mld;'+W.dragPickX+';'+W.dragPickY+';'+mod); addEvent('mlu;'+altClickX+';'+altClickY+';'+mod);
			// Blink target
			altClickTargetShow(mouseX,mouseY); setTimeout(altClickTargetHide,500);
		break;
		case 'Dbl':
			addEvent('mld;'+altClickX+';'+altClickY+';'+mod); addEvent('mlu;'+altClickX+';'+altClickY+';'+mod);
			// no break;
		case 'Lc':
			addEvent('mld;'+altClickX+';'+altClickY+';'+mod); addEvent('mlu;'+altClickX+';'+altClickY+';'+mod);
		break;
		case 'Rc':
			addEvent('mrd;'+altClickX+';'+altClickY+';'+mod); addEvent('mru;'+altClickX+';'+altClickY+';'+mod);
		break;
		case 'Mv':
			addEvent('mmv;'+altClickX+';'+altClickY+';'+mod);
		break;
		case 'Home':
			wl.goURL('/index.php');
	}
	sendEvents();
	if(action=='Cancel') altClickHideMenu();
	stopPropagation(e);
}
/**
 * Alt click: toggle Shift/Alt/Ctrl on/off
 */
function altClickCheck(cb){
	var cpt=dgi(cb).nextSibling;
	cpt.style.color=(dgi(cb).checked)?'':'red';
	dgi(cb).checked=(dgi(cb).checked)?false:'checked';
}






/************************************************************************************
 * Initialize scripts (called on body load)
 ************************************************************************************/
function init(){
	// Set inputBox and controlBox dimensions so content fit (WA)
	inputBoxesResetSize();

	// Init cache images
	for(var i=0;i<squaresNb;i++){
		imgBuff[i]=new Image();
		imgBuff[i].alt=i;
		imgBuff[i].onload=imgBuffLoaded;
	}

	// Set squares positions
	winResized();

	// Set squares srcs or init canvas stuff
	updateSquares();

	// Listen to events
	if(!altClick && !readOnly){
		connect(dgi('keys2'),'keydown',	keyAddSeq);
		connect(dgi('keys2'),'keyup',	keyAddSeq);
		if(keypressFix) connect(dgi('keys2'),'keypress',keyAddSeq);
		connect(D,'mousedown',	updateMouseEvents);
		connect(D,'mouseup',	updateMouseEvents);
		connect(D,'mousemove',	updateMousePos);
		if (W.addEventListener) W.addEventListener('DOMMouseScroll', updateMouseEvents, false); // FF mouse wheel
		else W.onmousewheel=D.onmousewheel = updateMouseEvents; // IE/Opera mouse wheel
	}
	else if(!readOnly) {
		connect(D,'mousedown',altClickShowMenu);
	}

	// Disable context menu
	D.oncontextmenu=function(event){
		if(!event) event=W.event;
		if(!event) return false;
		event.typeWA='mousedown';
		updateMouseEvents(event);
		event.typeWA='mouseup';
		updateMouseEvents(event);
		return false
	}

	// Start events timer
	setInterval(sendEvents,50);
}


/**
 * Monitor actions and currently pending requests to determine wether events must be sent or not
 */
function sendEvents(){
	var t=wl.chrono.microtime(),args,e;

	// Mobile keyboard input in progress: wait for end of typing
	if(W.updatePaused) return;

	if(!lastResponseTime) lastResponseTime=t; // init last response time

	// If alternate menu is shown, wait (or a debug stop is requested)
	if(refreshStop) return;

	// In case of no response after a given time, unlock events transmission
	if(sendEventsInProgress && (t-sendEventsInProgress > 6000)) sendEventsInProgress=0;

	// If a request is currently pending or mouse is currently doing a drag, wait
	if(sendEventsInProgress || maskDragInProgress) return;

	// If window is minimized, don't send
	if(winState=='minMax' || winState=='minNormal') return;

	// If an event has occured too recently, wait
	if(!refreshASAP){
		if(leftClicked && t-lastEventTime<wl.rVar.dblClickTime) return; // If waiting for the second left click of a double click
		if((lastEventTime!=0 && t-lastEventTime<wl.rVar.refreshAfterEvent && t-lastResponseTime<wl.rVar.refreshAfterNoEvent) ||
		(lastEventTime==0 && t-lastResponseTime<wl.rVar.refreshAfterNoEvent)) return;
	}

	clearMouseIcons();

	sendEventsInProgress=t;
	leftClicked=refreshASAP=lastEventTime=0;
	seq++;

	args={
		'seq':seq,
		'mixedEvents':mixedEvents,
		'winInnerWidth':getInnerWidth(),
		'winInnerHeight':getInnerHeight(),
		'orientation':W.orientation
	}

	// If image is not yet loaded, don't request a screen update
	if(wl.rVar.screenUpdateMethod=='canvas' && !maskImgLoaded) args.noScreenUpdate=1;

	// If an error has been detected during canvas drawing, re-update whole screen
	if(canvasDrawError) args.forceWholeScreenUpdate=1;

	// Send extra commands
	for(e in asyncCommands) args[e]=asyncCommands[e];
	asyncCommands={};

	// Send message
	wl.asr.send(args);

	// Reset events queue
	mixedEvents='';
}

// Function called by server at the end of an async
function asOK(){
	sendEventsInProgress=0;
	lastResponseTime=wl.chrono.microtime();
}
