<?php

/**
 * @desc Return data for theme block
 *
 * @return array(title,content,action)
 */
function uiConfigBlockTheme(){
	$title=outImage(outIcon('themeM'),false,false,'vertical-align:top;margin-right:1em').cfCaption('configAppearance');
	$content='<div style="position:absolute;width:100%;top:50%;margin-top:-1em;left:0">';
	$content.=cfCaption('configDefaultTheme').', '.cfCaption('loginMessage').', '.cfCaption('userAudioProfile').', '.cfCaption('configPopup').'...';
	$content.='</div>';
	$content.=outImage(outIcon('UI/configDown'),false,false,'position:absolute;left:10px;bottom:10px');
	$action="showFrame('theme',0,1)";

	return array('title'=>$title,'content'=>$content,'action'=>$action);
}


/**
 * @desc general parameters configuration items
 *
 */
function uiConfigFrameTheme(){
	global $resourceData;

	echo outDivframe('frame1');
	?>
	<div class="frame1Header"><?php
	uiConfigAdvancedConfigButton('theme');
	echo outImage(outIcon('themeM'),false,false,'margin-right:0.5em;vertical-align:middle').cfCaption('configAppearance');
	?>
	</div>
	<?php
	echo outConfigSeparator();

	/**
	 * Main UI theme & config
	 */
	echo outDivFrame('configFrame').'<div class="frame2Header">'.cfCaption('configUITheme').'</div>';

	// Main UI theme (skin, only if under Vista/Seven/Height & up...)
	if(WEnv::host()->isWindows() && ((cfGetHostOSVersion()=='OS_WIN32_WINDOWS_VISTA' || cfGetHostOSVersion()=='OS_WIN32_WINDOWS_SEVEN' || cfGetHostOSVersion()=='OS_WIN32_WINDOWS_HEIGHT') || (is_numeric(cfGGetVar('OSMajorVersion')) && cfGGetVar('OSMajorVersion')>=6))) {
		echo '<div style="display:none">';
		// Hidden control
		rcProcessData('skin',dataList,'default',array('default','aero'),array(
				array('default','default'),
				array('aero','aero')
			),true);
		echo '</div>';

		// block items control
		echo outBlockItem('uiSkinImgs','<img src="/themes/skins/default/preview.jpg" alt=""><br><center><b>Default</b></center>','id="uiSkinDefault"','margin-right:7px;margin-left:0px;padding:5px;',array('onclick'=>'uiSkinSet(\'default\')'),(('default'===$resourceData['skin'])?'sel':'unsel'));
		echo outBlockItem('uiSkinImgs','<img src="/themes/skins/aero/preview.jpg" alt=""><br><center><b>Aero</b></center>','id="uiSkinAero"','margin-right:7px;margin-left:0px;padding:5px;',array('onclick'=>'uiSkinSet(\'aero\')'),(('aero'===$resourceData['skin'])?'sel':'unsel'));
		echo '<br>';
	}
	else{
		/*
		rcProcessData('skin',dataList,((WEnv::host()->isOSX())?'osx':'default'),array('default','osx'),array(
			array(false,cfCaption('configUITheme')),
			array(
				array('default','default'),
				array('osx','osx')
			),false),true);
		*/
		echo '<div style="display:none">';
		rcProcessData('skin',dataList,'default',array('default'),array(
			array(false,cfCaption('configUITheme')),
			array(
				array('default','default')
			),false),true);
		echo '</div>';
	}

	// Visual notifications
	rcProcessData('visualNotification',dataBoolean,true,false,cfCaption('configPopup'),false);
	echo '&nbsp;&nbsp;&nbsp;';

	// Audio notifications
	rcProcessData('audioNotification',dataBoolean,true,false,outImageIcon('note').cfCaption('userAudioProfile'),false);

	// List audio profiles
	foreach (cfGlob(cfAppDocRoot().'/snd/*') as $cfn) if(is_dir($cfn)) {
		$audioProfiles[]=basename($cfn);
		$audioDefs[]=array(basename($cfn),basename($cfn));
	}
	// Audio profile control
	rcProcessData('audioProfile',dataList,'Default',$audioProfiles,array(
	array(false,'&nbsp;'),$audioDefs,false),true);

	echo '</div><br><br>';

	echo outConfigSeparator();

	/**
	 * Browser-side theme & configuration
	 */
	echo outDivFrame('configFrame').'<div class="frame2Header">'.cfCaption('configDefaultTheme').'</div>';

	//echo '<br><span style="margin-right:2em">';
	// Select default theme
	//echo outBt(cfCaption('genConfigure'),outIcon('theme'),'javascript:wl.UICommand(\'webPopup:/local/themeSelection.php\');');
	//echo '</span>';

	// Allow user theme change
	rcProcessData('allowUserThemeChange',dataBoolean,true,false,cfCaption('configUserSelectTheme'),false);

	// Popup windows management: noPopup=true => use HTML windows, noPopup=false => use regular popups
	rcProcessData('noPopup',dataBoolean,true,false,cfCaption('configNoPopup'),false,false);

	// Windows animations
	rcProcessData('windowsAnimation',dataBoolean,true,false,cfCaption('configWindowsAnimation'),true);


	// Theme selection
	echo '<iframe id="themeIFrame" style="display:none;height:550px;width:100%;padding:0;margin:0;border:0" src="themeSelection.php?userFile=general&WSESSID='.wSession_id().'"></iframe>';

	echo '</div>';

	// Login message
	echo '<br>'.outBt(cfCaption('loginMessage'),outIcon('info2'),'javascript:wl.UICommand(\'webPopup:/local/setLoginMessage.php\');');

	/***************************************************************************************************************************
	 *  Advanced config section
    ***************************************************************************************************************************/
	echo uiConfigAdvancedFrameHeader('theme');
		// Show splash screen at startup (non-reduced startup only)
		rcProcessData('showSplashScreen',dataBoolean, true, false, cfCaption('acShowSplashScreen'), true, false);

		// UI Fade effect
		rcProcessData('UIFadeEffect',dataBoolean, true, false, cfCaption('acUIFadeEffect'), false, false);
		echo outImageIcon('right');
		rcProcessData('mainFormFadeAlpha',dataNumeric,200,array(0,255),array(cfCaption('acMainFormFadeAlpha'),1,''),true,false);

		// Drag & launch parameters
		echo outImageIcon('dragLaunch');
		rcProcessData('dragNLaunchThreshold',dataNumeric,100,array(0,1000),array(cfCaption('acDragNLaunchThreshold'),1,''),false,false);
		echo outImageIcon('right');
		rcProcessData('dragNLaunchFriction',dataNumeric,0.005,array(0,1),array(cfCaption('acDragNLaunchFriction'),1,''),true,false);

	echo '</div>';

	echo '</div>';
}

if(!cfIsAsync() && @$_GET['command']!='backupDownload' && @$_GET['command']!='APCStats'){
?>
<script type="text/javascript">
function uiSkinSet(l){
	var i,items=D.getElementsByName("skin"),id='uiSkin'+l;

	for(i=0;i<items.length;i++){
		if(items[i].value==l) D.getElementsByName("skin")[i].checked="checked"
	}
	eSaveBt('skin',l);
}
</script>
<?php
}