<?php
/**
 * WebTV configuration file
 *
 * Configuration of type 2 photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     GREGG - Nicolas Bruley
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.8
 */

require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');

/*
 ***************************************************************************************************************************
 * Verify config rights
 ***************************************************************************************************************************
 */
$limitedConfig=rcConfigRights(false);

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

// Resource icon & name
rcInsertIconName($resourceData);


/**
 * Playlist selection
 */

// Seek playlists located into ./playlists
$playlists=array();
foreach (cfGlob(dirname(__FILE__).'/playlists/*.*') as $cfn){
	$name=cfFileWithoutExtension(basename($cfn));
	// Weezo-formated playlists
	if(cfFileExtension($cfn)=='ini'){
		$pl=cfParse_ini_file($cfn);
		if(isset($pl['url']) && isset($pl['scheme'])) {
			$playlists[]=array($name,cfUTF8Encode((@$pl['name'])?$pl['name']:$name));
			$playlistNames[]=$name;
		}
	}
	// Plain m3u files
	elseif (cfFileExtension($cfn)=='m3u'){
		$playlists[]=array($name,cfUTF8Encode(ucfirst($name)));
		$playlistNames[]=$name;
	}

}
$playlists[]=array('custom', cfCaption('genCustom'));
$playlistNames[]='custom';

// Display control
echo '<br><br><div class="frame2">';
echo '<div class="frame2Header">'.cfCaption('playlistSelect').'</div>';
rcProcessData('playlistName', dataList, 'world channels', $playlistNames, array(false,$playlists,false));
echo '<div style="visibility:hidden" id="customPlaylistDiv">';
rcProcessData('playlistCustom', dataFilePath, 'c:/', '*.m3u', array(cfCaption('genFile'), 25),false);
echo '</div>';
echo '</div>';

// Save / cancel buttons
echo rcButtonSaveCancel();

// Save/apply parameters
rcWriteResourceFile($resourceData, $fileName);

// Enable / disable profile detail on "display profile" button value
?>
<script language="javascript" type="text/javascript">
function dataChanged(dataName,dataValue){
	if(dataName=="playlistName") dgn("customPlaylistDiv").style.visibility = (dataValue=="custom")?'visible':'hidden';
}
function dataInitForm(){dataChanged("playlistName", dgn("playlistName").value)}
dataInitForm();
</script>