<?php
/**
 * RSS feed viewer
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.4.0
 */

require(INCLUDE_DIR.'mobileFunctions.php');

/**
 * @desc Init mobile specific data
 *
 */
function mobileChatInitResourceData(){
	if(cfRGetVar('mobileParametersLoaded')) return;

	// Tabs
	cfRSetVar('view','tabs');

	// Invert lines order
	cfRSetVar('invertOrder',true);

	cfRSetVar('mobileParametersLoaded',1);
}



// Init mobile specific data
mobileChatInitResourceData();

$input='<input id="textInput" class="textInput2" type="text" style="vertical-align:middle;width:90%;color:'.$colors[cfRGetVar('color')].'" onchange="sendMessage(this.value)" autocorrect="off" autocapitalize="off" onkeydown="kp(event)"/>';


/*
 ***************************************************************************************************************************
 * Insert HEAD, javascripts and comForm
 ***************************************************************************************************************************
 */
mfInsertHead(array('bodyExtraHTML'=>'onload="init()"','ping'=>'false','topControlsLabel'=>$input,'topControlsExtra'=>mfButton(false,'javascript:sendMessage(dgi(\'textInput\').value)',outIcon('ok32'))));

	?>
<script type="text/javascript">
var userId=<?php echo cfRGetVar('chatUserId');?>,tO,wdTO,userList=new Array(<?php
$fDisp=false;
foreach ($users as $userId=>$value) if($userId!='system'){
	if($fDisp) echo ','; else $fDisp=true;
	echo '"'.$userId.'"';
}
?>);
function init(){resetTimeout();dgi("textInput").focus()}
function kp(e){
	var kc=0;
	if(e&&e.which)kc=e.which;
	else if(W.event) kc=W.event.keyCode;
	if(kc==13 && dgi("textInput").value) sendMessage(dgi("textInput").value)
}
function resizeDivs(){}
function sendMessage(message){
	if(tO) clearTimeout(tO); tO=0;
	if(wdTO) clearTimeout(wdTO); wdTO=0;
	var ti=dgi('textInput');
	if(message){dgi('message').value=message;ti.value=""} else dgi('message').value="";
	if(ti.value=="") dgi('typing').value='0'; else dgi('typing').value='1';
	wdTO=setTimeout('sendMessage("*wdTO*")',<?php echo max(3*cfRGetVar('refreshMs'),3000); // Watchdog timer ?>)
	asyncSubmitForm('updateForm',message);
	ti.focus();
}
function updateMessages(nm, otherUser){
	dgi("chatDiv").innerHTML=nm+dgi("chatDiv").innerHTML;
	dgi("textInput").focus();
}
function resetTimeout(){
	if(wdTO) clearTimeout(wdTO); wdTO=0;
	if(tO) clearTimeout(tO);
	tO=setTimeout("sendMessage()",<?php echo cfRGetVar('refreshMs');?>);
}
function addUser(a, b){}
function showUser(a){}
function hideUser(a){}
function setUserTyping(a,b){}
function setUserWebcamOnline(a,b){}
function setUserWebcamOffline(a){}
function toggleWebcam(a,b){}
</script>
<form id="updateForm" enctype="multipart/form-data" method="POST" action="<?php echo $_SERVER['PHP_SELF'];?>" style="display:none">
<input name="message" id="message" type="text" />
<input name="command" id="command" type="text" />
<input name="typing" id="typing" type="text" />
</form>
<div class="frame1">
<div id="chatDiv" class="frame2" style="min-height:100px;height:80%;overflow:auto">
<?php echo resWebcamChatMessages(false);?>
</div>
</div>