<?php
/**
 * DEFAULT THEME LOGIN FORM
 *
 * Included by login.php
 * Display login form
 *
 * See /login.php for used variables
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

/*
 * List of parameters sent to loginForm.php script
 * - $_ENV['users'][] : arrays of user accounts to be displayed (array key is user id)
 *		user data :
 * 			['authenticationMethod'] : user authentication method : 'noAuthentication' or 'password'
 * 			['name'] (optional) : user name. Set to false if both name and user Id must be entered
 * 			['icon'] : user icon file basename (add /gfx/icons/ to have full path)
 * 			['hint'] (optional) : password hint, to be displayed
 * - $userToDisplay () optional : id of selected user (set if an user name has been passed in get args or if a wrong password has been typed),
 * 			(set to 0 (zero) if login+password) input must be selected)
 * - $userAndPasswordMethod : true if login+password form has been used
 * - $wrongPasswordSent : true if a wrong password has been entered
 * - $wrongUserSent : true if a non-existing user name has been entered
 * - $hiddenUsers : true if at least one hidden user account exists => user name+password form must be displayed
*/

die();

// number of forms to be displayed
$nbForms=count($_ENV['users']);
// sequential number of pre-selected form
if(isset($userToDisplay)){
	$i=0;
	foreach ($_ENV['users'] as $key=>$value) {if($key===$userToDisplay) $userToDisplaySeqNumber=$i;	$i++;}
}
else {
	if($nbForms==1){foreach ($_ENV['users'] as $key=>$value) {$userToDisplay=$key; $userToDisplaySeqNumber=0;}} else $userToDisplaySeqNumber=-1;
}



/*
 ***************************************************************************************************************************
 * Async Response
 ***************************************************************************************************************************
 */
if(cfIsAsync() && isset($_POST['user'])){
	echo cfAsyncHeader();

	// If security issue detected, display error message
	if($securityEvent)echo cfAsyncXMLJSaction('dgi("securityEvent").innerHTML="'.str_replace('"',"''",cfUTF8Encode($securityEvent)).'";');
	echo cfAsyncXMLJSaction('resetInputs();');
	if($wrongPasswordSent || $wrongUserSent){
		$errorText=str_replace('"',"''",(($wrongUserSent)?cfCaption('loginBadPasswordOrAccount'):cfCaption('loginBadPassword')));
		echo cfAsyncXMLJSaction('dgi("wrongPassword'.$userToDisplaySeqNumber.'").innerHTML="'.$errorText.'";');
	}
	echo cfAsyncXMLJSaction('show('.$userToDisplaySeqNumber.');if(dgi("password'.$userToDisplaySeqNumber.'")) dgi("password'.$userToDisplaySeqNumber.'").focus();');
	echo cfAsyncXMLJSaction('wl.mask.hide()');
	cfAsyncFooter();
}



/*
 ***************************************************************************************************************************
 * Display form (sync Response)
 ***************************************************************************************************************************
 */

// Insert HTML Head and Javascript
cfInsertHEAD(false);
$borderHeight=80;
?>
<style type="text/css">
.loginBody{background:#6DC32E}
.loginFrame{text-align:left;color:white}
.loginFrameHeader{position:absolute;top:25px; left:130px;font-size:20px}
.loginAuthIcon{position:absolute;top:20px; right:22px;}
.loginPwd{position:absolute;top:50px;left:130px;}
.loginPwdFrame{position:absolute;top:0px;left:0px;width:100%;height:100%}
.loginMessage{position:absolute;top:1em;right:1em;font-size:17px;border:1px solid white; padding:10px; background:url('loginMessageBg.png');}
.loginHint{font-size:13px;color:black}
.loginBadPwd{position:absolute;bottom:10px;left:130px;color:red;font-size:13px}
.loginEncrypt{color:black}
.loginBody select{background:#4CA817 !important}
</style>
<script language="JavaScript" type="text/javascript">
<!--
var classOut='loginFrame';
var classHover='loginFrameHover';
var cancelClick=false;
var currentUser=-1;
function initPage(){
<?php
	if($nbForms==1) echo 'show(0);';
?>
	setMax(); pos=maxPos; setMax();
	dgi('scrollDiv').style.top=pos+'px';
	dgi('f1').style.visibility='visible';
	fade('scrollDiv',0,1,<?php if(!cfBGetVar('png')||cfGetBrowser()=='ie') echo 1; elseif(cfBGetVar('fastAnim')) echo 15; else echo 4;?>);
}

function unlockClick(){cancelClick=false;}
function show(userNb) {
	if(cancelClick || (currentUser==userNb && currentUser!=-1)) return;

	if(userNb==-1){
		for(var i = 0; i < <?php echo $nbForms;?>; i++){
			dgi("if"+i).style.visibility="hidden";
			dgi("ao"+i).style.opacity="1";
			dgi("bgd"+i).style.display="none";
			if(i===currentUser){
				dgi("bgh"+i).style.display="block";
				dgi("bg" +i).style.display="none";
			}
			else{
				dgi("bgh"+i).style.display="none";
				dgi("bg"+i).style.display="block";
			}
		}
		cancelClick=true;
		window.setTimeout("unlockClick()",250);
	}
	else
	{
		for(var i = 0; i < <?php echo $nbForms;?>; i++){
			if (i!=userNb) {
				dgi("if"+i).style.visibility="hidden";
				dgi("ao"+i).style.opacity="0.4";
				dgi("bgd"+i).style.display="block";
				dgi("bgh"+i).style.display="none";
				dgi("bg"+i).style.display="none";
			}
			if (i==userNb) {
				if(dgi("usr"+i)) dgi("usr"+i).value=dgi("name"+i).innerHTML+"o";
				classHover='loginFrame';
				dgi("a"+i).className="loginFrame";
				dgi("if"+i).style.visibility="visible";
				dgi("ao"+i).style.opacity="1";
				dgi("bgd"+i).style.display="none";
				dgi("bgh"+i).style.display="block";
				dgi("bg"+i).style.display="none";

				if(dgi("password"+i)) {
					if(dgi("userName"+i)) dgi("userName"+i).focus(); else dgi("password"+i).focus();
				}
				else submitUser(i);
			}
		}
	}
	currentUser=userNb;
}
function resetInputs(){
	if(dgi("encryptionLockSend")) dgi("encryptionLockSend").style.display="none";
	for(var i = 0; i < <?php echo $nbForms;?>; i++){
		if(dgi("password"+i)) dgi("password"+i).value="";
		if(dgi("wrongPassword"+i)) dgi("wrongPassword"+i).innerHTML="&nbsp;";
	}
}
function eChgCls(objectid, action){
	if(currentUser==-1){
		if(action=="out") {dgi('bgh'+objectid).style.display="none";dgi('bg' +objectid).style.display="block";}
		if(action=="over"){dgi('bg' +objectid).style.display="none";dgi('bgh'+objectid).style.display="block";}
		return;
	}
	if(objectid!=currentUser){
		if(action=="out") {dgi('bg'+objectid).style.display="none";dgi('bgd'+objectid).style.display="block";}
		if(action=="over"){dgi('bgd'+objectid).style.display="none";dgi('bg'+objectid).style.display="block";}
	}
}
function submitUser(nb){
	document.loginForm.elements['userId'].value=dgi("userId"+nb).value;
	if(dgi("userName"+nb)) document.loginForm.elements['user'].value=dgi("userName"+nb).value; else document.loginForm.elements['user'].value='';
	if(dgi("password"+nb)) document.loginForm.elements['password'].value=dgi("password"+nb).value; else document.loginForm.elements['password'].value='';
	if(dgi("wrongPassword"+nb)) dgi("wrongPassword"+nb).innerHTML="&nbsp;";
	startEncryption();
}
function checkKey(e){
	if(currentUser==-1) return;
	var kc;
	if(e) kc=e.which; else {if(window.event) kc=window.event.keyCode; else return;}
	if(!kc) return;
	if(kc==13) {
		if(dgi("userName"+currentUser) && dgi("password"+currentUser).value=='') dgi("password"+currentUser).focus(); else submitUser(currentUser);
	}
	if(kc==27 || kc==0) {if(dgi("password"+currentUser)) dgi("password"+currentUser).value=""; show(-1);}
}
document.onkeypress=checkKey;
var pos=0;
var minPos=0;
var maxPos=500;
var vy=0;
var vYMax=80;
var vInt=false;
var dir;
var lastTime=0;
function scrolldown(){
	if(!dgi('scrollDiv')) return;
	setMax();
	if(vy>0) vy=0;
	if(maxPos==minPos) return;
	dir='down';
	if(vInt==false) vInt=window.setInterval('scrollAnim()',10);
	var now = new Date();
 	lastTime=now.getTime();
}
function scrollup(){
	if(!dgi('scrollDiv')) return;
	setMax();
	if(vy<0) vy=0;
	if(maxPos==minPos) return;
	dir='up';
	if(vInt==false) vInt=window.setInterval('scrollAnim()',10);
	var now = new Date();
 	lastTime=now.getTime();
}
function scrollAnim(){
	var now = new Date();
	var dt=now.getTime()-lastTime;
	//dgi('debug').innerHTML=dt;
	lastTime=now.getTime();
	setMax();
	if(dir=='down'){
		if(pos+3*vy<minPos) vy/=1.5;
		else if(Math.abs(vy)<vYMax) vy-=2;
	}
	else if(dir=='up'){
		if(pos+3*vy>maxPos) vy/=1.5;
		else if(Math.abs(vy)<vYMax) vy+=2;
	}
	else {
		vy/=1.5;
	}
	if(Math.abs(vy)<2) {
		vy=0;
		window.clearInterval(vInt);
		vInt=false;
	}
	pos+=vy*Math.min(dt,45)/45;
	dgi('scrollDiv').style.top=pos+'px';
}
function scrollBrake(){dir='brake';}
function setMax(){
	var h=dgi('scrollDiv').offsetHeight;
	var ah=dgi('bottomLine').offsetTop-dgi('topLine').offsetTop;
	if(h<ah){
		minPos=dgi('topLine').offsetTop + ah/2 - h/2;
		maxPos=minPos;
	}
	else {
		maxPos=dgi('topLine').offsetTop+10;
		minPos=dgi('bottomLine').offsetTop-h;
	}
	if(pos<minPos) {
		pos=minPos;
		dgi('scrollDiv').style.top=pos+'px';
	}
	if(pos>maxPos) {
		pos=maxPos;
		dgi('scrollDiv').style.top=pos+'px';
	}
	//dgi('a').innerHTML+=pos+" max:"+maxPos+" min:"+minPos;

	op=Math.min(1,Math.max(0,(maxPos-2-pos)/25)); fade('topArrow',op);
	op=Math.min(1,Math.max(0,(pos-2-minPos)/25)); fade('bottomArrow',op);
	dgi('topArrow').style.display='inline';
	dgi('bottomArrow').style.display='inline';
}
//-->
</script>
</head>
<?php
//<BODY>
echo '<body class="loginBody" style="overflow:hidden" onresize="setMax()">';

// Insert Login form and RSA encryption scripts and HTML
includeLoginFormAndScripts();

echo '<img src="'.cfAppThemeDir(true).'/loginBg.jpg" style="position:absolute;height:100%;width:100%;z-index:0" alt=""/>';
?>
<noscript>
<div><?php echo cfCaption('loginErrorNoJavascript'); ?></div>
</noscript>

<div id="a" style="position:absolute;width:100%; height:<?php echo $borderHeight; ?>px; background:black; display:block; <?php echo outCssOpacity(7);?>;z-index:1000;text-align:center;" onmouseover="scrollup()" onmouseout="scrollBrake()">
<?php echo outImage(outIcon('bigUp'),false,'id="topArrow"','margin-top:15px;'.outCssOpacity(0));?>
</div>
<div id="topLine" style="position:absolute;width:100%; left:0px; top:<?php echo $borderHeight; ?>px; height:1px; max-height:1px; background:white; display:block; overflow:hidden; <?php echo outCssOpacity(30);?>"></div>

<div style="position:absolute;width:100%; height:<?php echo $borderHeight; ?>px; bottom:0px; background:black; display:block; <?php echo outCssOpacity(7);?>;z-index:1000;text-align:center;" onmouseover="scrolldown()" onmouseout="scrollBrake()">
<?php echo outImage(outIcon('bigDown'),false,'id="bottomArrow"','margin-top:15px;'.outCssOpacity(0));?>
</div>
<div id="bottomLine" style="position:absolute;width:100%; left:0px; bottom:<?php echo $borderHeight; ?>px; height:1px; max-height:1px; background:white; display:block; overflow:hidden; <?php echo outCssOpacity(30);?>"></div>

<?php
// Cache frame images
echo '<div style="position:absolute;top:-9px;left:-9px;width:1px;height:1px;overflow:hidden">';
echo '<img src="'.cfAppThemeDir(true).'/loginFrame.png" alt="">';
echo '<img src="'.cfAppThemeDir(true).'/loginFrameH.png" alt="">';
echo '<img src="'.cfAppThemeDir(true).'/loginFrameD.png" alt="">';
echo '</div>';

// Login message
if(cfGGetVar('loginMessage')) echo '<div class="loginMessage">'.cfUTF8Encode(cfGGetVar('loginMessage'),false,false).'</div>';

echo '<div style="position:absolute; top:45px; left:0.5em; font-size:26px; color:white;z-index:1000">'.cfCaption('loginSelectAccount');
if(cfGGetVar('allowUserThemeChange')) echo '<br/><br/>'.outThemeSelectionControl('general',false,'POST');
echo "</div>\n";

echo '<div style="position:absolute;width:100%;height:100%;overflow:hidden;" id="mDiv">';

// User Table
echo '<div id="scrollDiv" style="width:100%;position:absolute;top:0px;'.outCssOpacity(0).'">';
echo '<center><div id="f1" style="width:500px;">';
$i=0;
/*
 * for each user
 */
foreach ($_ENV['users'] as $key=>$value){
	// User login frame
	echo '<div id="a'.$i.'" class="loginFrame" style="position:relative;height:133px;" onclick="show('.$i.');" onmouseover="eChgCls(\''.$i.'\', \'over\');" onmouseout="eChgCls(\''.$i.'\', \'out\');">';
	echo outImage(cfAppThemeDir(true).'/loginFrame.png', false,'id="bg' .$i.'"','position:absolute;display:'.(($userToDisplaySeqNumber==-1) ? 'block' : 'none'));
	echo outImage(cfAppThemeDir(true).'/loginFrameD.png',false,'id="bgd'.$i.'"','position:absolute;display:'.(($userToDisplaySeqNumber!=-1 && $i!=$userToDisplaySeqNumber) ? 'block' : 'none'));
	echo outImage(cfAppThemeDir(true).'/loginFrameH.png',false,'id="bgh'.$i.'"','position:absolute;display:'.(($i==$userToDisplaySeqNumber) ? 'block' : 'none'));

	// Opacity frame
	echo '<div id="ao'.$i.'" style="position:absolute;width:100%;height:100%;'.(($userToDisplaySeqNumber==-1 || $i==$userToDisplaySeqNumber) ? '' : outCssOpacity(40)).'">';

	// User name
	if($value['name']) echo '<div id="name'.$i.'" class="loginFrameHeader">'.cfUTF8Encode($value['name']);
	elseif($nbForms>1) echo '<div id="name'.$i.'" class="loginFrameHeader">'.cfCaption('loginOtherGroup');
	else echo '<div id="name'.$i.'" class="loginFrameHeader">'.cfCaption('loginConnectButton');
	echo "</div>\n";

	// User authentication method icon
	echo '<div class="loginAuthIcon">';
	if($value['authenticationMethod']=='noAuthentication')
		echo outImage(outIcon('public'),false,false,'margin-left:1em; vertical-align:middle;');
	else
		echo outImage(outIcon('restricted'),false, false,'margin-left:1em; vertical-align:middle;');
	echo "</div>\n";


	// User icon
	$iconName='/gfx/icons/default.jpg';
	if(file_exists(cfAppDocRoot()."/gfx/icons/".$value['icon'])) $iconName="/gfx/icons/".$value['icon'];
	echo '<div style="position:absolute;top:25px;left:20px">';
	echo '<div style="border:1px solid #555; padding:1px; background:white">'.outImage($iconName,false,false,false,1,true,true)."</div>\n";
	echo '</div>';

	// if user to load, show form, else don't
	if($i===$userToDisplaySeqNumber) echo '<div id="if'.$i.'" class="loginPwdFrame">';
	else echo '<div  id="if'.$i.'" style="visibility:hidden;">';

	//userId hidden field
	echo '<input type="text" id="user'.(0+$i).'" value="'.str_replace('"','&quote;',cfUTF8Encode($value['name'])).'" style="display:none">';
	echo '<input type="hidden" id="userId'.(0+$i).'" value="'.$key.'">';


	if($value['authenticationMethod']=='password') {
		echo '<div class="loginForm">';
		//password input and group input (if hidden group)
		echo '<table class="loginPwd"><tr><td>';
		if(!$value['name']) echo cfCaption('genGroup').'</td><td><input type="text" id="userName'.(0+$i).'" size="16" style="margin-bottom:3px;margin-left:1em"></td></tr><tr><td>';
		echo cfCaption('genPassword').'</td><td><input type="password" id="password'.(0+$i).'" size="16" style="margin-left:1em">';

		// Hint
		if(isset($value['hint']) && strlen(trim($value['hint']))>0) echo '</td></tr><tr><td colspan="2" class="loginHint">'.cfCaption('logHint').cfCaption('genSeparator').cfUTF8Encode($value['hint']);
		echo "</td></tr></table>\n";

		echo '<div class="loginBadPwd" id="wrongPassword'.(0+$i).'">';
		if($i==$userToDisplaySeqNumber && $wrongPasswordSent) echo cfCaption('loginBadPassword'); else echo '&nbsp;'; // if wrong password sent, display an error message
		echo '</div>';

		// submit button
		echo "<input type=\"text\" id=\"usr".$i."\" style=\"visibility:hidden;\" size=5>";
		echo outButton(cfCaption('loginConnectButton'),'javascript:submitUser('.(0+$i).');',outIcon('pwd'),false,false,'style="position:absolute;top:87px;right:20px;"');

		// Change user button
		echo outButton(false,'javascript:show(-1)',outIcon('change'),cfCaption('loginChangeUser'),false,'style="position:absolute;top:20px;right:20px;"').'&nbsp;';
		echo '</div>';
	}
	echo "</div>\n";
	echo "</div></div><br/>\n";
	$i++;
}
echo '</center>';

echo "</div>\n";

echo '</div>';

echo '<span onclick="window.open(\''.APP_SITE.'\')" style="cursor:pointer; position:absolute;bottom:7px; right:7px">Weezo&nbsp;'.outImage(outIcon('logoSmall'),'#',false,'vertical-align:top; margin-left:1em').'</span>';

// If error message div
echo '<div style="position:absolute;top:10px;right:10px;color:red; text-align:right" id="securityEvent">'.(($securityEvent)?cfUTF8Encode($securityEvent):'').'</div>';

echo '<script type="text/javascript">initPage();show('.$userToDisplaySeqNumber.')</script>';
echo "</body></html>";
?>